/*********************************************************************

  Filename:  style.cpp
  Chapter:   C      Appendix C - C++ Language Guide
  Section:   C.14   Style Examples and Pragmatics
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

// Code exhibiting style characteristics
//  Title: style

#include <iostream.h>
#include <stdlib.h>

#define MAX  16000

int sum(int n)
{
   int i, total = 0;

   for (i = 0; i < n; ++i) {
     total += i;
     if (total > MAX) {
	cout << "too large" << endl;
	exit(1);
     }
   }
   return (total);
}


main ()
{
   for (int i = 0; i < 1000; i += 50)
      cout << "\nI is " << i << "  sum is " << sum(i);
   return (0);
}