/*********************************************************************

  Filename:  style2.cpp
  Chapter:   C      Appendix C - C++ Language Guide
  Section:   C.14   Style Examples and Pragmatics
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

// Code exhibiting style characteristics
//  Title: style_too

#include <iostream.h>

//Algol style matching braces
int order(int& y, int& z)
{
   int temp;

   if (z < y)
   {
      temp = z; z = y; y = temp;
   }
   return z;
}

main ()
{
   int i, j;

   i = 5;
   j = 10;
   cout << "\nBefore order i is " << i << "  and j is " << j << endl;
   order(i, j);   //C++ style
   cout << "After  order i is " << i << "  and j is " << j << endl;
   i = 6;
   j = 2;
   cout << "Before order i is " << i << "  and j is " << j << endl;
   order(i, j);
   cout << "After  order i is " << i << "  and j is " << j << endl;

   i = 15;
   return (0);
}