/*********************************************************************

  Filename:  virt_sel.cpp
  Chapter:   C      Appendix C - C++ Language Guide
  Section:   C.10   Functions - Virtual Functions
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//virtual function selection
//  Title: virtual_selection

#include <iostream.h>

class B {
public:
   int  i;
   virtual void print_i() { cout << i << " inside B\n"; }
};

class D : public B {
public:
   void print_i() { cout << i << " inside D\n"; }
};

main()
{
    B   b;
    B*  pb = &b;
    D   f;

    f.i = 1 + (b.i = 1);
    pb -> print_i();
    pb = &f;
    pb -> print_i();
    return (0);
}
