/*********************************************************************

  Filename:  circles.cpp
  Chapter:   2      C++ as a Better C
  Section:   2.1    Comment Style
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//The computation of circumference and area of circles.
//  Title: circles
//                   by
//             Geometrics Inc.
//             Version 2.2

#include <iostream.h>

const  float pi = 3.14159;  //pi accurate to six places
const  int true = 1;        //mnemonic identifier

inline float circum(float rad){ return (pi * 2 * rad); }
inline float area(float rad){ return (pi * rad * rad); }

main()
{
   float  r;

   while ( true ) {   //exit with control-C
      cout <<"\nEnter radius: ";   //prompt for input
      cin >> r;
      cout << "\nArea is " << area(r);
      cout << "\nCircumference is " << circum(r) << endl;
      return (0);
   }
}
