/*********************************************************************

  Filename:  scope.cpp
  Chapter:   2      C++ as a Better C
  Section:   2.5    Scope Resolution Operator
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//  ::  scope resolution operator
//  Title: scope_operator

#include <iostream.h>

int i = 1;           // external i

main()
{
   int   i = 2;         //redeclares i locally

   {
       cout << "enter inner block\n";
       int  n = i;      //the global i is still visible
       int  i = 3;      //hides both the global i and external i

       /// print the local i and external i
       cout << i  << "  i <> ::i  " << ::i << "\n";
       cout << "n = " << n << "\n";
   }
   cout << "enter outer block\n";
   cout << i  << "  i <> ::i  " << ::i << "\n";
   return (0);
}
