/*********************************************************************

  Filename:  stackpri.cpp
  Chapter:   3      Classes
  Section:   3.5    Visibility private and public
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//An elementary implementation of type stack.
//  Title: stack_private

#include <iostream.h>

const int max_len = 1000;
enum boolean { false, true };

struct stack {
public:
   void reset() { top = EMPTY; }
   void push(char c) { top++; s[top] = c; }
   char pop() { return( s[top--] ); }
   char top_of() { return( s[top] ); }
   boolean empty() { return (boolean)(top == EMPTY); }
   boolean full() { return (boolean)(top == FULL); }
private:
   char s[max_len];
   int  top;
   enum { EMPTY = -1, FULL = max_len - 1 };
};

main()
{
   stack  s;
	char str[40] = {"My name is Don Knuth!\n"};
   int    i = 0;

   cout << str << "\n";
   s.reset();
   while (str[i])
      if (!s.full())
         s.push(str[i++]);
   while (!s.empty())
      cout <<  s.pop();
   cout << "\n";
   return (0);
}
