/*********************************************************************

  Filename:  multi_v.cpp
  Chapter:   4      Constructors and Destructors
  Section:   4.8    Members that are Class Types
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

// Title: multi_vect

#include "vect.h"

class multi_v {
public:
   vect a, b, c;
   multi_v(int i) : a(i), b(i), c(i), size(i) { }
   int ub() const { return (size - 1); }
private:
   int size;
};

main()
{
    multi_v a_w_h(5);  //age weight and height

    for (int i = 0; i <= a_w_h.a.ub(); ++i) {
       a_w_h.a.element(i) = 21 + i;
       a_w_h.b.element(i) = 135 + i;
       a_w_h.c.element(i) = 62 + i;
    }
    for (i = 0; i <= a_w_h.a.ub(); ++i) {
       cout << a_w_h.a.element(i) << " years ";
       cout << a_w_h.b.element(i) << " pounds ";
       cout << a_w_h.c.element(i) << " inches\n";
    }
    return (0);
}
