/*********************************************************************

  Filename:  salary.cpp
  Chapter:   4      Constructors and Destructors
  Section:   4.5    static and const member functions
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//Salary calculation using
//static members.
//  Title: salary

#include <iostream.h>

class salary {
public:
   salary(int b) : b_sal(b) { }
   void calc_bonus(double perc) { your_bonus = b_sal * perc; }
   static void reset_all(int p) {all_bonus = p; }
   int comp_tot() const
      { return (b_sal + your_bonus + all_bonus); }
private:
   int        b_sal;
   int        your_bonus;
   static int all_bonus;  //declaration
};

int salary::all_bonus = 100; //declaration and definitoin

main()
{
   salary w1(1000), w2(2000);

   w1.calc_bonus(0.2);
   w2.calc_bonus(0.15);
   salary::reset_all(400);
   cout << " w1 " << w1.comp_tot() << "  w2 " << w2.comp_tot() << "\n";
   return (0);
}