/*********************************************************************

  Filename:  override.cpp
  Chapter:   6      Inheritance
  Section:   6.11   Exercises
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//Override v. Overload
//  Title: overriding

#include <iostream.h>

class B {
public:
   B(int j = 0): i(j) {}
   virtual void print() const { cout << " i = " << i << endl; }
   void print(char *s) const { cout << s << i << endl; }
private:
   int i;
};

class D: public B {
public:
   D(int j = 0): B(5), i(j) {}
   void print() const { cout << " i = " << i << endl; }
   int print(char *s) const { cout << s << i << endl; return (i); }
private:
   int i;
};

main()
{
   B  b1, b2(10), *pb;
   D  d1, d2(10), *pd = &d2;

   b1.print();
   b2.print();
   d1.print();
      d2.print();
   b1.print("b1.i = ");
   b2.print("b2.i = ");
   d1.print("d1.i = ");
   d2.print("d2.i = ");
   pb = pd;
   pb -> print();
   pb -> print("d2.i = ");
   pd -> print();
   pd -> print("d2.i = ");
   return (0);
}
