/*********************************************************************

  Filename:  purepoly.cpp
  Chapter:   6      Inheritance
  Section:   6.5    Virtual Functions
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//virtual function selection
//  Title: pure_polymorphism

#include <iostream.h>

class B {
public:
   int  i;
   virtual void print_i() { cout << i << " inside B\n"; }
};

class D : public B {
public:
   void print_i() { cout << i << " inside D\n"; } //virtual as well
};

main()
{
    B   b;
    B*  pb = &b;
    D   f;

    f.i = 1 + (b.i = 1);
    pb -> print_i();     //calls B::print_i()
    pb = &f;             //points at a D object
    pb -> print_i();     //calls D::print_i()
    return (0);
}
