/*********************************************************************

  Filename:  tools.cpp
  Chapter:   6      Inheritance
  Section:   6.7    Multiple Inheritance
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//  Title: tools

#include <iostream.h>

class tools {
public:
   int cost() { return (1); }
};

class labor {
public:
   int cost() {return (2); }
};

class parts {
public:
   int cost() {return (3); }
};

class plans : public tools, public parts, public labor {
public:
   int tot_cost() { return (parts::cost() + labor::cost()); }
};

main()
{
   int    price;
   plans* ptr;
   tools  t;
   labor  l;
   parts  p;
   plans  pl;

   price = ptr -> tools::cost();
   cout << "\ntools cost = " << t.cost()
        << "  labor cost = " << l.cost()
        << "  parts cost = " << p.cost()
        << "  plans cost = " << pl.tot_cost()
        << "  total cost = " << price << endl;
   return (0);
}
