/*********************************************************************

  Filename:  virtual.cpp
  Chapter:   6      Inheritance
  Section:   6.5    Virtual Functions
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//  Title: virtual

#include <iostream.h>

class B {
public:
   virtual foo(int)  { cout << "B(int)" << endl; }
   virtual foo(double) { cout << "B(double)" << endl; }
};

class D: public B {
public:
   foo(int) { cout << "D(int)" << endl; }
};

main()
{
   D d;
   B b, *pb = &d;

   b.foo(9);       //selects B::foo(int)
   b.foo(9.5);     //selects B::foo(double)
   d.foo(9);       //selects D::foo(int)
   d.foo(9.5);     //selects D::foo(int)
   pb -> foo(9);   //selects D::foo(int)
   pb -> foo(9.5); //selects B::foo(double)
   return (0);
}