/*********************************************************************

  Filename:  array.cpp
  Chapter:   7      Templates
  Section:   7.3    Class Templates
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//Get storage off stack for array
//  Title: array

#include <iostream.h>

template <int n, class T>
class assign_array {
public:
   T a[n];
};

main()
{
   assign_array<50, double> x, y;
   int i;

   for (i = 0; i < 50; ++i)
      x.a[i] = i;
   for (i = 0; i < 50; ++i)
      y.a[i] = i * 2;
   for (i = 0; i < 50; ++i)
      cout << x.a[i] << "\t";
   for (i = 0; i < 50; ++i)
      cout << y.a[i] << "\t";
   x = y;                     //should work efficiently
   for (i = 0; i < 50; ++i)
      cout << x.a[i] << "\t";
   return (0);
}