/*********************************************************************

  Filename:  basic_i.cpp
  Chapter:   D      Appendix D - Input/Output
  Section:   D.4    The Input C istream
  Compiler:  Borland C++     Version 3.1       Summer 1993

  Ira Pohl   Object Oriented Programming Using C++

*********************************************************************/

//  Title: basic_input

#include <fstream.h>

main()
{
   double x;
   int    i;
   char   c;
   char   s[100];  //max of 99 chars

   cout << "\nEnter one character: ";
   cin.get(c);           //one character
   cout << "\nCharacter is " << c << endl;

   cout << "\nEnter a float and an int: ";
   cin.ignore(100, '\n');      //flush input buffer up to 100 chars to \n
   cin >> x >> i;
   cout << "\nFloat is " << x << "  int is " << i << endl;

   cout << "\nEnter up to 40 character string:\n";
   cin.ignore(100, '\n');          //flush chars out of cin buffer
   cin.get(s, 40);       //length 40 or terminated by '\n'
   cout << "\nString is: " << s;

   cout << "\nEnter a string (will terminate at length 10 or by *):\n";
   cin.ignore(100, '\n');         //flush chars out of cin buffer
   cin.get(s, 10, '*');  //length 10 or terminated by *
   cout << "\nString is: " << s;

   cout << "\nEnter a string (will terminate at length 10 or by *):\n";
   cin.ignore(100,'\n');        //flush chars out of cin buffer
   cin.get(s, 10, '*');  //length 10 or terminated by *
   cout << "\nString is: " << s;
   cout << endl;
   return (0);
}