/*********************************************************************

  Filename:  mix_io.cpp
  Chapter:   D      Appendix D - Input/Output
  Section:   D.8    Mixing I/O Libraries
  Compiler:  Borland C++     Version 3.1       Summer 1993

  Ira Pohl   Object Oriented Programming Using C++

*********************************************************************/

//Mix C and C++ I/O.
//  Title: mix_io

#include <stdio.h>
#include <iostream.h>

unsigned long fact(int n)
{
   unsigned long f = 1;
   for (int i = 2; i <= n; ++i)
      f *= i;
   return (f);
}

main()
{
   int n;

   ios::sync_with_stdio();
   do {
      cout << "\nEnter n positive or 0 to halt: ";
      scanf("%d", &n);
      printf("\n fact(%d) = %ld", n, fact(n));
   } while (n > 0);
   cout << "\nend of session" << endl;
   return (0);
}
