/*********************************************************************

  Filename:  word_cnt.cpp
  Chapter:   D      Appendix D - Input/Output
  Section:   D.7    Functions and Macros in ctype.h
  Compiler:  Borland C++     Version 3.1       Summer 1993

  Ira Pohl   Object Oriented Programming Using C++

*********************************************************************/

//A word count program
//  Title: word_cnt

//Usage: executable < file

#include   <iostream.h>
#include   <ctype.h>

main()
{
   int   word_cnt = 0;
   int   found_next_word();

   while (found_next_word())
      ++word_cnt;
   cout << "word count is " << word_cnt << endl;
   return (0);
}

int found_next_word()
{
   char   c;
   int    word_sz = 0;

   cin >> c;
   while ( !cin.eof() && !isspace(c)) {
      ++word_sz;
      cin.get(c);
   }
   return (word_sz);
}

