/*********************************************************************

  Filename:  c_pair.cpp
  Chapter:   C      Appendix C - C++ Language Guide
  Section:   C.9    Classes - The THIS pointer
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//This pointer
//  Title: c_pair

#include <iostream.h>

class c_pair {
public:
   c_pair(char b) { c1 = 1 + (c2 = b); }
   c_pair increment() { c1++; c2++; return (*this); }
   unsigned where_am_I() { return ((unsigned)this); }
   void print() { cout << c1 << c2 << "\t"; }
private:
   char     c1, c2;
};

main()
{
   c_pair  a('A'), b('B'), c('D');

   a.print();
   cout << " is at " << a.where_am_I() << endl;
   b.print();
   cout << " is at " << b.where_am_I() << endl;
   c.increment().print();
   cout << " is at " << c.where_am_I() << endl;
   return (0);
}