/*********************************************************************

  Filename:  def_args.cpp
  Chapter:   C      Appendix C - C++ Language Guide
  Section:   C.10   Default Arguments
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//Default arguments
//  Title: default_arguments

#include <iostream.h>

//Raise n to the k power

int mult(int n, int k = 2)   	//k = 2 is default
{
   if (k == 2)
      return (n * n);
   else
      return (mult(n, k - 1) * n);
}

main()
{
   int i, j;
   i = 3;
   cout << "\nThis program outputs 8 squared and 8 cubed\n";
   cout << mult(i + 5) << "   "  << mult(i+5, 3) << endl;
   return (0);
}
