/*********************************************************************

  Filename:  string_t.cpp
  Chapter:   1      Overview of C++ and Object Oriented Programming
  Section:   1.5    Overloading
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//An elementary implementation of type string.
//  Title: string_test

#include <string.h>
#include <iostream.h>

const int max_len = 255;

class string {
public:
	void assign(const char* st) { strcpy(s, st); len = strlen(st); }
	int  length() { return (len); }
	void print() { cout << s << "\nLength: " << len << "\n"; }
private:
   char s[max_len];
   int  len;
};

//Test of the class string.
main()
{
   string  one, two;
   char three[40] = {"My name is Charles Babbage."};

   one.assign("My name is Alan Turing.");
   two.assign(three);
   cout << three;
   cout << "\nLength: " << strlen(three) << endl;
   //Print shorter of one and two.
   if (one.length() <= two.length())
      one.print();
   else
      two.print();
}

