/*********************************************************************

  Filename:  constant.cpp
  Chapter:   2      C++ as a Better C
  Section:   2.2    Avoiding the Preprocessor: inline and const
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//  Title: constants

#include <iostream.h>

const false = 0;           //implicit type is int
const double e = 2.71828;  //natural logarithm base
const int M_size = 100;    //to be used in an array declaration
const *p = &M_size;        //a pointer to a constant int
char* const s = "abcde";   //a constant pointer to char

main ()
{
   cout << "\nfalse = " << false;
   cout << "\ne = " << e;
   cout << "\nM_size = " << M_size;
   cout << "\ns = " << s;
   return (0);
}