/*********************************************************************

  Filename:  prototyp.cpp
  Chapter:   2      C++ as a Better C
  Section:   2.6    Function Prototypes
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//Compute the average of a set of int values.
//  Title: prototypes

#include <iostream.h>

int data[10] = {99, 87, 67, 90, 66, 43, 89, 88, 97, 76};

void print_array(const char*, const int*, int);
void print_double(const char* name, double x);
double average(const int a[], int size);

main()
{
   print_array("data", data, 10);
   print_double("average", average(data, 10));
   return (0);
}

void print_int(const char* name, int k)
{
    cout << name << " = " << k << endl;
}

void print_double(const char* name, double x)
{
    cout << name << " = " << x << endl;
}

void print_array(const char* name, const int a[], int size)
{
    cout << name ;
    print_int(" array, size ", size);
    for (int i = 0; i < size; ++i)
       cout << a[i] << "\t";
    cout << endl;
}

double average(const int a[], int size)   //compute average
{
    double  sum = 0.0;

    for (int i = 0; i < size; ++i)
       sum += a[i];
    return ( (double) sum / size);
}

