/*********************************************************************

  Filename:  static.cpp
  Chapter:   3      Classes
  Section:   3.7    Static Members
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//  Title: static_members

#include <iostream.h>
#include <string.h>

class str {
   char s[100];
public:
   static int how_many;      //declaration
   void print();
   void assign(const char*);
};


void str::print()
{
    cout << s << "\n";
}

void str::assign(const char* a)
{
   strcpy(s,a);
}

int str::how_many = 0;   //definition and initialization

main()
{
   str s1, s2, s3, *p;
   str::how_many = 3;
   s1.assign("This is first");
   s2.assign("This is second");
   s3.assign("This is third");
   str t;
   t.how_many++;   //have another string, update count
   t.assign("This is fourth");
   p = new str;
   p -> how_many++;   //have another string, update count
   p -> assign("This is last");

   s1.print();
   s2.print();
   s3.print();
   t.print();
   p -> print();
   cout << "This is how many : " << str::how_many << endl;
   delete p;   //get rid of one and decrement how_many
   str::how_many--;
   cout << "This is how many : " << t.how_many << endl;   //another way to reference how_many
}
