/*********************************************************************

  Filename:  s_stack.cpp
  Chapter:   3      Classes
  Section:   3.4    Member Functions
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//An elementary implementation of type stack.
//  Title: s_stack

#include <iostream.h>

const int max_len = 1000;
enum boolean { false, true };

struct stack {
   //data representation

   char s[max_len];
   int  top;
   enum { EMPTY = -1, FULL = max_len - 1 };

   //operations represented as member functions

   void reset() { top = EMPTY; }
   void push(char c) { top++; s[top] = c; }
   char pop() { return( s[top--] ); }
   char top_of() { return( s[top] ); }
	boolean empty() { return (boolean) (top == EMPTY); }
	boolean full() { return (boolean) (top == FULL); }
};


main()
{
   stack  data, operands;
   stack* ptr_operands = &operands;
   char   tempchar;

   data.reset();
   operands.reset();
   ptr_operands -> push('A');
   data.push('C');
   data.push('B');
   cout << "\n" << operands.top_of();
   cout << "\t" << data.top_of();
   tempchar = data.pop();
   cout << "\t" << data.top_of();
   cout << "\t" << tempchar << "\n";
   return (0);
}