/*********************************************************************

  Filename:  c_pair.cpp
  Chapter:   4      Constructors and Destructors
  Section:   4.4    The this pointer
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

// Use of the this pointer
// The keyword this points to the object for which
// a member function is called
//  Title: c_pair


#include <iostream.h>

class c_pair {
public:
   c_pair(char b): c1(b), c2(b+1) { }
   c_pair increment() { c1++; c2++; return (*this); }
   unsigned where_am_I() { return ((unsigned)this); }
   void print() { cout << c1 << c2 << "\t"; }
private:
      char c1, c2;
};

main()
{
    c_pair   a('A'), b('B'), c('D');
    a.print();
    cout << " is at " << a.where_am_I() << "\n";
    b.print();
    cout << " is at " << b.where_am_I() << "\n";
    c.increment().print();
    cout << " is at " << c.where_am_I() << "\n";
    return (0);
}

