/*********************************************************************

  Filename:  modulo.cpp
  Chapter:   4      Constructors and Destructors
  Section:   4.1    Classes with Constructors
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//Modulo numbers and constructor initialization
//  Title: modulo

#include <iostream.h>

const int modulus = 60;
class mod_int {
public:
   mod_int(int i) { v = i % modulus; }
   void assign(int i) { v = i % modulus; }
   void print() { cout << v << "\t" ; }
private:
   int v;
};

main()
{
   int seconds = 400;
   mod_int z(seconds);

   cout << seconds << " seconds equals "
        << seconds / 60 << " minutes ";
   z.print();
   cout << " seconds\n";
   return (0);
}
