/*********************************************************************

  Filename:  coerce.cpp
  Chapter:   7      Templates
  Section:   7.3    Class Templates
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

//  Title: coerce

#include <iostream.h>

enum boolean {false, true};

template <class T1, class T2>
boolean coerce(T1& x, T2 y)
{
   if (sizeof(x) < sizeof(y))
      return false;
   else
      x = (T1)y;
      return true;
}

main()
{
   int i, j;
   float  x;
   double y;
   char   ch1;

   cout << "\nIf coersions took place, same values\n";
   i = 1;  j = 2;
   cout << "\ncoerce int, int = ";
   cout << (int)coerce(i, j);
   cout << "   i = " << i << "  j = " << j;


   i = int('a');   ch1 = 'b';
   cout << "\ncoerce int, ch  = ";
   cout << (int)coerce(i, ch1);
   cout << "   i = " << (char)i << "  ch1 = " << ch1;

   i = int('a');  ch1 = 'b';
   cout << "\ncoerce ch,  int = ";
   cout << (int)coerce(ch1, i);
   cout << "   i = " << (char)i << "  ch1 = " << ch1;

   x = 1.1;   y = 2.2;
   cout << "\ncoerce fl,  dbl = ";
   cout << (int)coerce(x, y);
   cout << "   x = " << x << "  y = " << y;

   x = 1.1;  y = 2.2;
   cout << "\ncoerce dbl, fl  = ";
   cout << (int)coerce(y, x);
   cout << "   x = " << x << "  y = " << y;
   cout << endl;
   return (0);
}