/*********************************************************************

  Filename:  bools.cpp
  Chapter:   9      OOP Using C++
  Section:   9.2    ADTs in non-OOP Languages
  Compiler:  Borland C++     Version 3.1       Summer 1993

  C++ for C Programmers, Edition 2     By Ira Pohl

*********************************************************************/

// Show use of boolean type to return answer

#include <iostream.h>

const int N = 5;   //size of age tables
enum boolean { FALSE, TRUE };


boolean search(int table[], int x, int& where)
{
   where = -1;
   for (int i = 0; i < N; ++i)
      if (x == table[i]) {
	 where = i;
	 break;
      }
   return boolean(where != -1);
}

main()
{
   int   ages1[] = { 4, 49, 39, 87, 36, 33};
   int   ages2[] = {14, 89, 39, 22, 34, 88};
   int   element_no;
   int   check_el = 49;

   if (search(ages1, check_el, element_no))
      cout << "\n" << check_el << " found at " << element_no << endl;

   if (search(ages2, check_el, element_no))
      cout << "\n" << check_el << " found at " << element_no << endl;
   else
      cout << "\n" << check_el << " not found: null is " << element_no << endl;
   return (0);
}